<template>
  <AppModal
    name-modal="modal-applicability"
    :width-modal="586"
    :visible="visible"
    :no-header="true"
    @before-close="beforeClose"
    init-class="modalApplicability">
    <!-- TODO: содержимое модалки и script абсолютно идентичны применяемости из -->
    <!-- TODO: components/redesign/part-applicability.vue -->
    <!-- TODO: необходимо этот блок вынести, чтобы он формировался только в 1 месте!-->
    <div
      slot="body"
      class="applicability">
      <div class="applicability-header">
        <h2 class="heading _prime-font __medium">
          Подходит к автомобилям
        </h2>
        <div class="input -action-search">
          <input
            class="input-field"
            type="text"
            placeholder="Марка, модель или модификация"
            @input="onInput">
          <span class="input-action _search">
            <img
              svg-inline
              src="~/assets/svg/redesign/magnifer-bold.svg">
          </span>
        </div>
      </div>
      <!--TODO: Improve в таблице сделать virtual scroll -->
      <div class="applicability-body">
        <div class="applicability-table">
          <div class="applicability-table-header">
            <div class="tr">
              <div
                v-for="(field, i) in structure"
                :key="`table-th-${i}`"
                :class="`th _${field.name}`">
                <template v-if="field.sorting.has">
                  <!-- Классы для направления сортировки: -sorting-up / -sorting-down -->
                  <button
                    class="table-button-sorting"
                    :class="sortClasses[field.sorting.criteria]"
                    @click="orderChange(field.sorting.criteria)">
                    <span>{{ field.title }}</span>
                    <img
                      svg-inline
                      src="~/assets/svg/redesign/sorting-none.svg">
                    <img
                      svg-inline
                      src="~/assets/svg/redesign/sorting.svg">
                  </button>
                </template>
                <template v-else>
                  {{ field.title }}
                </template>
              </div>
            </div>
          </div>
          <div class="applicability-table-body">
            <div
              class="tr"
              v-for="(entity, j) in filteredEntities"
              :key="`${entity[structure[0].name] + j}`">
              <div
                class="td"
                v-for="(field, k) in structure"
                :key="`heading-${j}-${k}`"
                :class="`_${field.name}`">
                <TextHighlight :queries="queries">
                  {{ entity[field.name] }}
                </TextHighlight>
              </div>
            </div>
          </div>
          <div
            class="applicability-table-footer"
            v-show="!filteredEntities.length">
            <span>По вашему запросу не найдено подходящих автомобилей</span>
          </div>
        </div>
      </div>
    </div>
  </AppModal>
</template>

<script>
import { isEmpty, orderBy, has } from 'lodash-es';
import Modals from '~/assets/js/mixins/redesign/modals';

import AppModal from '~/components/redesign/app-modals/app-modal';
import AppButton from '~/components/redesign/app-buttons/app-button';

const TextHighlight = process.client ? require('vue-text-highlight').default : null;

export default {
  name: 'AppModalApplicability',
  components: {
    AppModal,
    AppButton,
    TextHighlight,
  },
  mixins: [Modals],
  props: {
    headings: {
      type: Array,
      default() {
        return [];
      },
    },
    entities: {
      type: Array,
      default() {
        return [];
      },
    },
    structure: {
      type: Array,
      default() {
        return [];
      },
    },
    visible: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      searchString: '',
      order: {
        field: this.structure[0],
        direction: 'asc',
      },
      queries: [],
    };
  },
  computed: {
    filteredEntities() {
      return orderBy(this.entities, [this.order.field], [this.order.direction])
        .filter(item => isEmpty(this.queries) || this.hasMatch(item));
    },
    sortClasses() {
      const direction = Object.assign({}, this.$options.direction);

      if (has(direction, this.order.field)) {
        direction[this.order.field] = (this.order.direction === 'asc' ? '-sorting-up' : '-sorting-down');
      }

      return direction;
    },
  },
  created() {
    this.$options.direction = this.structure.reduce((acc, currentField) => {
      acc[currentField] = 'none';
      return acc;
    }, {});
  },
  methods: {
    onInput(value) {
      this.queries = value.target.value.trim().split(/\s+/);
      this.$emit('input', this.queries);
    },
    orderChange(field) {
      const newOrder = {
        field,
        direction: 'asc',
      };

      if (field === this.order.field) {
        newOrder.direction = this.order.direction === 'asc' ? 'desc' : 'asc';
      }
      this.order = newOrder;
    },

    hasSubstring(string, substring) {
      return string.toLowerCase().includes(substring.toLowerCase());
    },
    hasMatch(entity) {
      return this.queries
        .some(query => this.structure.some(field => this.hasSubstring(entity[field.name], query)));
    },
    beforeClose() {
      this.searchString = '';
      this.queries = [];
      this.$emit('before-close');
    },
  },
};
</script>

<style lang="postcss">
  .modalApplicability {
    .applicability {
      .applicability-header {
        > .input.-action-search {
          width: 100%;
        }
      }

      .applicability-table {
        > .applicability-table-body {
          max-height: 25rem;
          overflow-y: auto;
        }

        .tr {
          .th, .td {
            min-width: 33.333%;
          }

          /*AlexCzech*/

          .td > span {
            max-width: 9.875rem;
            text-overflow: ellipsis;
            white-space: nowrap;
            overflow: hidden;
          }
        }

        .tfooter {
          padding: 1.5rem;
          text-align: center;
        }
      }
    }

    @media screen and (min-width: 981px) {
      .applicability {
        .applicability-header {
          display: flex;
          align-items: center;
          padding: 0 3rem 0 1.625rem;
          width: 100%;
          height: 3.5rem;
          border-bottom: 1px solid var(--border-color-main);
          background-color: var(--bg-dark);
          .heading {
            font-weight: var(--font-weight-bold);
            font-size: .875rem;
          }
        }
      }
    }

    @media screen and (max-width: 980px) {
      min-height: 100vh;
      max-height: 100vh;

      .applicability {
        .applicability-header {
          position: sticky;
          top: 0;
          padding-top: 3rem;
          background-color: var(--bg-main);
        }
        .applicability-table .applicability-table-body {
          max-height: none;
        }
      }
    }
  }

</style>
